<?php

namespace App\Models;

use Eloquent as Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Factories\HasFactory;

/**
 * Class ProductInPromo
 *
 * @package App\Models
 * @version September 27, 2021, 5:29 pm WAT
 * @property string $product_name
 * @property integer $indexPos
 * @property int $id
 * @property \Illuminate\Support\Carbon|null $created_at
 * @property \Illuminate\Support\Carbon|null $updated_at
 * @method static \Database\Factories\ProductInPromoFactory factory(...$parameters)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromo newModelQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromo newQuery()
 * @method static \Illuminate\Database\Query\Builder|ProductInPromo onlyTrashed()
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromo query()
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromo whereCreatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromo whereId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromo whereIndexPos($value)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromo whereProductName($value)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromo whereUpdatedAt($value)
 * @method static \Illuminate\Database\Query\Builder|ProductInPromo withTrashed()
 * @method static \Illuminate\Database\Query\Builder|ProductInPromo withoutTrashed()
 * @mixin Model
 */
class ProductInPromo extends Model
{

    use HasFactory;

    public $table = 'products_in_promo';

    const CREATED_AT = 'created_at';
    const UPDATED_AT = 'updated_at';




    public $fillable = [
        'product_name',
        'indexPos'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'product_name' => 'string',
        'indexPos' => 'integer'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        'created_at' => 'nullable',
        'updated_at' => 'nullable',
        'product_name' => 'required|string|max:255',
        'indexPos' => 'required|integer'
    ];


}
