<?php

namespace App\Models;

use Eloquent as Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Factories\HasFactory;

/**
 * Class ProductInPromoByDay
 *
 * @package App\Models
 * @version September 27, 2021, 5:30 pm WAT
 * @property integer $product_id
 * @property string $theDay
 * @property integer $quantity
 * @property boolean $is_day_process
 * @property int $id
 * @property \Illuminate\Support\Carbon|null $created_at
 * @property \Illuminate\Support\Carbon|null $updated_at
 * @method static \Database\Factories\ProductInPromoByDayFactory factory(...$parameters)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromoByDay newModelQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromoByDay newQuery()
 * @method static \Illuminate\Database\Query\Builder|ProductInPromoByDay onlyTrashed()
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromoByDay query()
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromoByDay whereCreatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromoByDay whereId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromoByDay whereIsDayProcess($value)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromoByDay whereProductId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromoByDay whereQuantity($value)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromoByDay whereTheDay($value)
 * @method static \Illuminate\Database\Eloquent\Builder|ProductInPromoByDay whereUpdatedAt($value)
 * @method static \Illuminate\Database\Query\Builder|ProductInPromoByDay withTrashed()
 * @method static \Illuminate\Database\Query\Builder|ProductInPromoByDay withoutTrashed()
 * @mixin Model
 */
class ProductInPromoByDay extends Model
{

    use HasFactory;

    public $table = 'products_in_promo_by_day';

    const CREATED_AT = 'created_at';
    const UPDATED_AT = 'updated_at';




    public $fillable = [
        'product_id',
        'theDay',
        'quantity',
        'is_day_process'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'product_id' => 'integer',
        'theDay' => 'date',
        'quantity' => 'integer',
        'is_day_process' => 'boolean'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        'created_at' => 'nullable',
        'updated_at' => 'nullable',
        'product_id' => 'required',
        'theDay' => 'required',
        'quantity' => 'required|integer',
        'is_day_process' => 'required|boolean'
    ];


}
