<?php

namespace App\Repositories;

use App\Models\Player;
use App\Repositories\BaseRepository;

/**
 * Class PlayerRepository
 * @package App\Repositories
 * @version September 27, 2021, 5:24 pm WAT
*/

class PlayerRepository extends BaseRepository
{
    /**
     * @var array
     */
    protected $fieldSearchable = [
        'nom',
        'prenom',
        'quartier',
        'telephone',
        'montant_depense',
        'status_user',
        'tombola_num'
    ];

    /**
     * Return searchable fields
     *
     * @return array
     */
    public function getFieldsSearchable()
    {
        return $this->fieldSearchable;
    }

    /**
     * Configure the Model
     **/
    public function model()
    {
        return Player::class;
    }
}
