<?php namespace Tests\APIs;

use Illuminate\Foundation\Testing\WithoutMiddleware;
use Illuminate\Foundation\Testing\DatabaseTransactions;
use Tests\TestCase;
use Tests\ApiTestTrait;
use App\Models\ProductInPromo;

class ProductInPromoApiTest extends TestCase
{
    use ApiTestTrait, WithoutMiddleware, DatabaseTransactions;

    /**
     * @test
     */
    public function test_create_product_in_promo()
    {
        $productInPromo = ProductInPromo::factory()->make()->toArray();

        $this->response = $this->json(
            'POST',
            '/api/product_in_promos', $productInPromo
        );

        $this->assertApiResponse($productInPromo);
    }

    /**
     * @test
     */
    public function test_read_product_in_promo()
    {
        $productInPromo = ProductInPromo::factory()->create();

        $this->response = $this->json(
            'GET',
            '/api/product_in_promos/'.$productInPromo->id
        );

        $this->assertApiResponse($productInPromo->toArray());
    }

    /**
     * @test
     */
    public function test_update_product_in_promo()
    {
        $productInPromo = ProductInPromo::factory()->create();
        $editedProductInPromo = ProductInPromo::factory()->make()->toArray();

        $this->response = $this->json(
            'PUT',
            '/api/product_in_promos/'.$productInPromo->id,
            $editedProductInPromo
        );

        $this->assertApiResponse($editedProductInPromo);
    }

    /**
     * @test
     */
    public function test_delete_product_in_promo()
    {
        $productInPromo = ProductInPromo::factory()->create();

        $this->response = $this->json(
            'DELETE',
             '/api/product_in_promos/'.$productInPromo->id
         );

        $this->assertApiSuccess();
        $this->response = $this->json(
            'GET',
            '/api/product_in_promos/'.$productInPromo->id
        );

        $this->response->assertStatus(404);
    }
}
