<?php namespace Tests\APIs;

use Illuminate\Foundation\Testing\WithoutMiddleware;
use Illuminate\Foundation\Testing\DatabaseTransactions;
use Tests\TestCase;
use Tests\ApiTestTrait;
use App\Models\ProductInPromoByDay;

class ProductInPromoByDayApiTest extends TestCase
{
    use ApiTestTrait, WithoutMiddleware, DatabaseTransactions;

    /**
     * @test
     */
    public function test_create_product_in_promo_by_day()
    {
        $productInPromoByDay = ProductInPromoByDay::factory()->make()->toArray();

        $this->response = $this->json(
            'POST',
            '/api/product_in_promo_by_days', $productInPromoByDay
        );

        $this->assertApiResponse($productInPromoByDay);
    }

    /**
     * @test
     */
    public function test_read_product_in_promo_by_day()
    {
        $productInPromoByDay = ProductInPromoByDay::factory()->create();

        $this->response = $this->json(
            'GET',
            '/api/product_in_promo_by_days/'.$productInPromoByDay->id
        );

        $this->assertApiResponse($productInPromoByDay->toArray());
    }

    /**
     * @test
     */
    public function test_update_product_in_promo_by_day()
    {
        $productInPromoByDay = ProductInPromoByDay::factory()->create();
        $editedProductInPromoByDay = ProductInPromoByDay::factory()->make()->toArray();

        $this->response = $this->json(
            'PUT',
            '/api/product_in_promo_by_days/'.$productInPromoByDay->id,
            $editedProductInPromoByDay
        );

        $this->assertApiResponse($editedProductInPromoByDay);
    }

    /**
     * @test
     */
    public function test_delete_product_in_promo_by_day()
    {
        $productInPromoByDay = ProductInPromoByDay::factory()->create();

        $this->response = $this->json(
            'DELETE',
             '/api/product_in_promo_by_days/'.$productInPromoByDay->id
         );

        $this->assertApiSuccess();
        $this->response = $this->json(
            'GET',
            '/api/product_in_promo_by_days/'.$productInPromoByDay->id
        );

        $this->response->assertStatus(404);
    }
}
