<?php namespace Tests\APIs;

use Illuminate\Foundation\Testing\WithoutMiddleware;
use Illuminate\Foundation\Testing\DatabaseTransactions;
use Tests\TestCase;
use Tests\ApiTestTrait;
use App\Models\SendSmsCmr;

class SendSmsCmrApiTest extends TestCase
{
    use ApiTestTrait, WithoutMiddleware, DatabaseTransactions;

    /**
     * @test
     */
    public function test_create_send_sms_cmr()
    {
        $sendSmsCmr = SendSmsCmr::factory()->make()->toArray();

        $this->response = $this->json(
            'POST',
            '/api/send_sms_cmrs', $sendSmsCmr
        );

        $this->assertApiResponse($sendSmsCmr);
    }

    /**
     * @test
     */
    public function test_read_send_sms_cmr()
    {
        $sendSmsCmr = SendSmsCmr::factory()->create();

        $this->response = $this->json(
            'GET',
            '/api/send_sms_cmrs/'.$sendSmsCmr->id
        );

        $this->assertApiResponse($sendSmsCmr->toArray());
    }

    /**
     * @test
     */
    public function test_update_send_sms_cmr()
    {
        $sendSmsCmr = SendSmsCmr::factory()->create();
        $editedSendSmsCmr = SendSmsCmr::factory()->make()->toArray();

        $this->response = $this->json(
            'PUT',
            '/api/send_sms_cmrs/'.$sendSmsCmr->id,
            $editedSendSmsCmr
        );

        $this->assertApiResponse($editedSendSmsCmr);
    }

    /**
     * @test
     */
    public function test_delete_send_sms_cmr()
    {
        $sendSmsCmr = SendSmsCmr::factory()->create();

        $this->response = $this->json(
            'DELETE',
             '/api/send_sms_cmrs/'.$sendSmsCmr->id
         );

        $this->assertApiSuccess();
        $this->response = $this->json(
            'GET',
            '/api/send_sms_cmrs/'.$sendSmsCmr->id
        );

        $this->response->assertStatus(404);
    }
}
